#ifndef ADS1292__H__
#define ADS1292__H__

#ifdef __cplusplus
extern "C" {
#endif
          
#include "stdint.h"
#include "nrf_spi_mngr.h"


// Define ports for UCA0
#define SPI_UCA0_PORT_SEL     P2SEL
#define SPI_UCA0_CS_PORT_OUT  P5OUT
#define SPI_UCA0_CS_PORT_SEL  P5SEL
#define SPI_UCA0_CS_PORT_DIR  P5DIR

#define SPI_UCA0_CLK             BIT0
#define SPI_UCA0_SIMO            BIT4
#define SPI_UCA0_SOMI            BIT5

#define SPI_UCA0_CS              BIT2

// define ads pin
#define ADS1292_DRDYB_OUT     P1OUT
#define ADS1292_DRDYB_DIR     P1DIR
#define ADS1292_DRDYB_SEL     P1SEL
#define ADS1292_DRDYB_IN      P1IN
#define ADS1292_DRDYB_IFG     P1IFG
#define ADS1292_DRDYB_REN     P1REN
#define ADS1292_DRDYB_IE      P1IE
#define ADS1292_DRDYB_IES     P1IES
#define ADS1292_DRDYB         BIT1

#define ADS1292_CLKSEL_OUT    P5OUT
#define ADS1292_CLKSEL_DIR    P5DIR
#define ADS1292_CLKSEL_SEL    P5SEL
#define ADS1292_CLKSEL        BIT4

#define ADS1292_CLK_SEL       P1SEL
#define ADS1292_CLK_DIR       P1DIR
#define ADS1292_CLK           BIT2

#define ADS1292_START_OUT     P1OUT
#define ADS1292_START_DIR     P1DIR
#define ADS1292_START_SEL     P1SEL
#define ADS1292_START         BIT4

#define ADS1292_PWDNB_OUT     P1OUT
#define ADS1292_PWDNB_DIR     P1DIR
#define ADS1292_PWDNB_SEL     P1SEL
#define ADS1292_PWDNB         BIT7

#define ADS1292_WAKEUP_CMD    0x02 // Wake-up from standby mode
#define ADS1292_STANDBY_CMD   0x04 // Enter standby mode
#define ADS1292_RESET_CMD     0x06 // Reset the device
#define ADS1292_START_CMD     0x08 // Start/restart (synchronize) conversions
#define ADS1292_STOP_CMD      0x0A // Stop conversion
#define ADS1292_RDATAC_CMD    0x10 // Enable Read Data Continous mode
#define ADS1292_SDATAC_CMD    0x11 // Stop Read Data Continous mode
#define ADS1292_RDATA_CMD     0x12 // Read data by command; supports multiple read back

#define ADS1292_REG_ID        0x00
#define ADS1292_REG_CONFIG1   0x01
#define ADS1292_REG_CONFIG2   0x02
#define ADS1292_REG_LOFF      0x03
#define ADS1292_REG_CH1SET    0x04
#define ADS1292_REG_CH2SET    0x05
#define ADS1292_REG_RLD_SENS  0x06
#define ADS1292_REG_LOFF_SENS 0x07
#define ADS1292_REG_LOFF_STAT 0x08
#define ADS1292_REG_RESP1     0x09
#define ADS1292_REG_RESP2     0x0A
#define ADS1292_REG_GPIO      0x0B


void initAds1292(nrf_spi_mngr_callback_end_t data_cb_fnc);

void ads1292ReadStart(void);
void ads1292ReadStop(void);
	
void ads1292ReadAllReg(void);
void ads1292ReadData(void);

#ifdef __cplusplus
}
#endif

#endif /* ADS1292__H__ */
